//
//  It is file 'archdr.hpp'
//
//  Copyright (C) 1992, 1993 Serge Pachkovsky, ps@che.nsk.su
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
//  Archived file format is simple:
//	at the very beginning there is ArchiveSignature,
//  followed by one or more compressed data blocks.
//	each compressed data block consists of 32-bit BlockSize (header
//  size included), CRC32 (calculated on uncompressed data of entire compression
//  block, including filename), amount of memory mecessary for decompression
//  and compression order, followed by compressed block data.
//	compressed block data contains 32-bit FileLength, 64-bit area
//  reserved for future use (initialized with zeros), 16-bit length of the
//  file name, file name itself plus actual file data.
//
//  All 16 and 32-bit quantities should be in little-endian order.
//  Decompressor will take care of the machine native representation...
//
const	char	ArchiveSignature[] = "PSA\1\3" ;

struct UncomprHdr {
    unsigned long	BlockSize ;
    unsigned long	CRC32 ;
    unsigned short	MemoryUsed ;
    unsigned short	ComprOrder ;	    // 0xFFFF means uncompressed data follows
    unsigned short	CharsCount ;
    //
    //	That's not exactly C struct now, but it looks much nicer...
    //	If you change definition of this structure, don't forget
    //	to modify byte layout in archdr.cc!
    //
    static ByteOrder	Layout ;
    } ;

struct ComprHdr {
    unsigned long	FileLength ;
    TimeStamp		Modified ;	    // and yet another...
    unsigned short	reserved[ 3 ] ;     // Should be filled w/zeros
    unsigned short	NameLength ;
    //
    //	That's not exactly C struct now, but it looks much nicer...
    //	If you change definition of this structure, don't forget
    //	to modify byte layout in archdr.cc!
    //
    static ByteOrder	Layout ;
    } ;

//
//  These declarations are for stupid compilers (like GCC ;), which like
//  to pad structured till next God-knows-which boundary...
//
const	int	    SizeOfUncomprHdr	= 14 ;
const	int	    SizeOfComprHdr	= 16 ;
