//
//  It is file 'archive.hpp'
//
//  Copyright (C) 1992, 1993 Serge Pachkovsky, ps@che.nsk.su
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
const	char	    DefaultArchiveExtension[] = ".psa" ;

const	int	    BlockCopyBuffer	      = 4 * 1024 ;

class Archive {
    char	   *name ;
    const char	   *err_msg ;
    int 	    handle ;
    char	    incomplete ;
    void	    FetchBlockHeader( UncomprHdr & ) ;
    public:
		    Archive() ;
		   ~Archive() ;
    int 	    Open( const char * const ) ;
    int 	    Create( const char * const = NULL ) ;
    int 	    Close( void ) ;
    int 	    Delete( void ) ;
    int 	    Backup( void ) ;
    int 	    Rename( const char * const = NULL ) ;
    void	    Perror( const char * const = NULL ) const ;
    int 	    Eof( void ) const ;
    char * const    GetName( void ) const ;
    //
    //	These functions will abort if something bad happens...
    //
    void	    NextEntry( void ) ;
    void	    FillFileInfo( FileInfo & ) ;
    void	    CopyCurrentFragment( class Archive & ) ;
    void	    CompressFile( char * const name, int order, unsigned long memory ) ;
    int 	    ExtractCurrentFragment() ;
    int 	    TestCurrentFragment() ;
    } ;
