//
//  It is file 'buf_file.hpp'
//
//  Copyright (C) 1992, 1993 Serge Pachkovsky, ps@che.nsk.su
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#ifdef MSDOS
const	char	NullDevice[]   = "nul" ;
const	char	ModeBinWrite[] = "wb" ;
const	char	ModeBinRead[]  = "rb" ;
#else
const	char	NullDevice[] = "/dev/null" ;
const	char	ModeBinWrite[] = "w" ;
const	char	ModeBinRead[]  = "r" ;
#endif

class BufferedFile {
    public:
    FILE *	    f ;
    CompletionCode  code ;

		BufferedFile( const char * const name, const char *mode ) ;
	       ~BufferedFile() ;
    void	Close() ;
    int 	GetByte() ;
    int 	PutByte( BYTE ) ;
    void	Rewind() ;
    } ;


#ifdef GEN_HUGE_FUNCS
HugeInline
BufferedFile::BufferedFile( const char * const name, const char *mode )
{
f = xfopen( name, mode ) ;
if( f == NULL ){
    perror( name ) ;
    code = FileNotFound ;
    return ;
    }
if( setvbuf( f, NULL, _IOFBF, IOBufSize ) != 0 ){
    perror( name ) ;
    fclose( f ) ;
    f	 = NULL ;
    code = OutOfMemory ;
    return ;
    }
code = Completed ;
}

HugeInline void
BufferedFile::Close()
{
if( f != NULL )
    fclose( f ) ;
f = NULL ;
}

HugeInline
BufferedFile::~BufferedFile()
{
Close() ;
}
#endif

inline int
BufferedFile::GetByte()
{
return getc( f ) ;
//    int c = getc( f ) ;
//cout << char( c ) ;
//return c ;
}

inline int
BufferedFile::PutByte( BYTE c )
{
return putc( c, f ) ;
}

inline void
BufferedFile::Rewind()
{
rewind( f ) ;
}
