//
//  It is file 'namelist.hpp'
//
//  Copyright (C) 1992, 1993 Serge Pachkovsky, ps@che.nsk.su
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
const char AllFiles[]	= "*" ;

struct FileEntry {
    struct FileEntry   *next ;
    char	       *name ;
			FileEntry( const char * const ) ;
		       ~FileEntry() ;
    int 		Match( const char * name, int recursive ) const ;
    } ;

struct FileList {
    int 		recursive ;
    FileEntry	       *first ;
    FileEntry	      **last ;
			FileList() ;
		       ~FileList() ;
    void		Add( const char * const ) ;
    int 		InList( const char * name ) const ;
    int 		Empty() ;
    void		Recursive() ;
    } ;

class NameList {
    FileList	    includes ;
    FileList	    excludes ;
    public:
    void	    AddName( const char * const ) ;
    void	    AddNamesFile( const char * const ) ;
    void	    ExcludeName( const char * const ) ;
    void	    Recursive() ;
    int 	    InList( const char * name ) const ;

    friend class    NameListIterator ;
    } ;

class NameListIterator {
    NameList	   *list ;
    FileEntry	   *current_entry ;
    DirGen	   *generator ;
    void	    InitGenerator() ;
    public:
		    NameListIterator( NameList & ) ;
		   ~NameListIterator() ;
    int 	    HaveNames( void ) ;
    void	    Next() ;
    char * const    Name() const ;
    } ;
