//
//  It is file 'scoreboard.hpp'
//
//  Copyright (C) 1992, 1993 Serge Pachkovsky, ps@che.nsk.su
//
//	The idea of implementing scoreboard with mark value instead
//	of clearing array each time we are going to start new board
//	belongs to Sam Paik (paik@mlo.dec.com). It was a clever thing
//	to come up with!
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
class ScoreBoard {
    int 	    check_count ;
    short           mark_value ;
    short  	    board[ CharsCount ] ;
    public:
		    ScoreBoard( void ) ;
    void	    Set    ( CharType i ) ;
    Boolean	    Checked( CharType i ) ;
    void	    Clear  ( void ) ;
    int 	    CheckCount() ;
    } ;

inline
ScoreBoard::ScoreBoard( void )
{
mark_value = SHRT_MAX - 1 ; // Force clearing scoreboard array on
		     	    // next call to Clear...
Clear() ;
}

inline void
ScoreBoard::Set( CharType i )
{
if( board[ i ] != mark_value ){
     check_count++ ;
     board[ i ] = mark_value ;
     }
}

inline Boolean 
ScoreBoard::Checked( CharType i )
{
return board[ i ] == mark_value ? True : False ;
}

inline void
ScoreBoard::Clear( void )
{
check_count = 0 ;
if( ++mark_value >= SHRT_MAX ){
	mark_value = 1 ;
	memset( board, 0, sizeof board ) ;
	}
}

inline int
ScoreBoard::CheckCount( void )
{
return check_count ;
}
